; Externs:;
;   TestInput (input: al)
; Declares:
;   DefaultInput
;   PutSequence
;   GetHistory0
;   GetHistory1
;   GetHistory2
;   GetHistory3
;   GetHistory4

bits 16
org 100h

InputHistory: ; Main program is reused as input buffer
_main:
	mov es, [2Ch]
	mov ah, 49h
	int 21h
	
	mov ax, cs
	;mov ds, ax
	les di, [I16ptr]
	shl eax, 16
	mov ax, INT16
	cli
	push es
	 push si
	  les si, [es:di] ; Load old I16 pointer
	  cmp [es:si-8], dword 0x494C4853
	  je UninstallI16
AfterUninstallI16:
	 pop si
	pop es
	cmp [UninstalledSegment], word 0
	jne SkipI16install
	 xchg eax, [es:di]
	 mov [OldI16], eax
	 sti
SkipI16install:

	mov ax, cs
	;mov ds, ax
	les di, [I10ptr]
	shl eax, 16
	mov ax, INT10
	cli
	push es
	 push si
	  les si, [es:di] ; Load old I10 pointer
	  cmp [es:si-8], dword 0x494C4853
	  je UninstallI10
AfterUninstallI10:
	 pop si
	pop es
	cmp [UninstalledSegment], word 0
	jne UninstalledExit
	 xchg eax, [es:di]
	 mov [OldI10], eax
	 sti

	;;mov dx, LogFileName
	;;mov ah, 3Ch
	;;mov cx, 40h
	;;int 21h
	;;mov [LogFileHandle], ax
	
	push ds
	 mov ax, 0xB800
	 mov ds, ax
	 mov di, 160*5-16*2
	 mov dx, 17
	 mov ax, 0x0200
yloop:	 dec dx
	 jz disploopdone
	 mov cx, 17
xloop:   dec cx
         jz yloopnext
         mov bx, ax
         cmp al, 0x1C
         jb nspecial
         cmp al, 20h
         jb special
         cmp al, 80h
         jb nspecial
         cmp al, 0xB0
         je nspecial
         cmp al, 0xB1
         je nspecial
         cmp al, 0xBF
         je nspecial
         cmp al, 0xC4
         je nspecial
         cmp al, 0xB3
         je nspecial
         cmp al, 0xD9
         je nspecial
         cmp al, 0xDA
         je nspecial
         cmp al, 0xC3
         je nspecial
         cmp al, 0xB4
         je nspecial
         cmp al, 0xBA
         je nspecial
         cmp al, 0xBB
         je nspecial
         cmp al, 0xCD
         je nspecial
         cmp al, 0xC9
         je nspecial
         cmp al, 0xC8
         je nspecial
         cmp al, 0xFE
         je nspecial
         cmp al, 0xDF
         je nspecial
         cmp al, 0xDC
         je nspecial
special: mov bh, 6
nspecial:
         mov [di], bx
         inc di
         inc di
         inc ax
         jmp xloop
yloopnext:
	 add di, 160-16*2
	 jmp yloop
disploopdone:
	pop ds
	
	mov dx,InstalledText ; Display text
	mov ah,9
	int 21h
	call InstallFont
	mov dx, End          ; Calculate TSR
	sub dx, _main        ; size and do TSR.
	add dx, 15
	shr dx, 4
	add dx, 10h
	mov ax, 3100h
	int 21h
UninstallI16:
	; Input: ES:SI = Address of INT16 routine of the JAINPUT instance to remove
	; Changes: DS, DI
	push ds
	 mov eax, [es:si-4]
	 lds di, [cs:I16ptr]
	 mov [di], eax ; Restore old INT
	pop ds
	sti
	mov [UninstalledSegment], es
	jmp AfterUninstallI16
UninstallI10:
	; Input: ES:SI = Address of INT10 routine of the JAINPUT instance to remove
	; Changes: DS, DI
	push ds
	 mov eax, [es:si-4]
	 lds di, [cs:I10ptr]
	 mov [di], eax ; Restore old INT
	pop ds
	sti
	mov [UninstalledSegment], es
	jmp AfterUninstallI10

UninstalledExit:
	sti
	mov es, [UninstalledSegment]
	mov ah, 49h ; Free the code segment
	int 21h
	push cs     ; Display text
	pop ds
	mov dx,UninstalledText
	mov ah,9
	int 21h
	mov ax, 4C00h ; Exit
	int 21h
InputHistoryEnd:;

I10ptr: dw 10h*4, 0
I16ptr: dw 16h*4, 0
UninstalledSegment dw 0
InstalledText:
	db 'JAINPUT - Makeshift 8-bit Japanese IME for DOS',13,10
	db 'Copyright (C) 2011-03-03 Joel Yliluoma, http://iki.fi/bisqwit/',13,10
	db 'JAINPUT','Ѐ ҂؝Ǘ҂ֆ҂',0xFF
	db 32
	db 'Ɩ-҂- Ѐ : ', EnableToggleKey
	db 13,10,'$'
UninstalledText:
	db 'JAINPUT unloaded.',13,10
	db '$'

FlipFlop equ InputHistoryEnd+0
I16Mode  equ InputHistoryEnd+4
WhatWasThatInputAgain equ InputHistoryEnd+6
CurrentPtr equ UninstalledSegment

;;LogFileName db 'jainput.log',0
;;LogFileHandle dw 0

;;;;;;;;;;;;;;;;;;;;;
;;; FONT GUARDIAN ;;;
;;;;;;;;;;;;;;;;;;;;;
I10sig: dd 0x494C4853
OldI10	dw 0,0
INT10:	push ax
	 and ax, 0xFF7F
	 cmp ax, 0003h
	pop ax
	ja GotoOldI10
	pushf
	call far [cs:OldI10]
	push ax
	 push bx
	  push cx
	   push dx
	    push bp
	     call InstallFont
	    pop bp
	   pop dx
	  pop cx
	 pop bx
	pop ax
	iret
GotoOldI10:
	jmp far [cs:OldI10]

InstallFont:
	;mov dx, 0x3DA
	;in al, dx
	;test al, 8
	;jz InstallFont ; Loop until vrefresh or something
	push es
	 push cs
	 pop es
	 mov ax, 1100h
	 mov bh, 16   ; Bytes per character
	 xor bl, bl   ; Which block to load in map 2
	 mov cx, 4
	 mov dx, 0x1C
	 mov bp, FontData_Part1
	 int 10h
	 mov cx, 0x80
	 mov dx, 0x80
	 mov bp, FontData_Part2
	 int 10h
	pop es
	ret

;;;;;;;;;;;;;;;;;;;;;;;;
;;; INPUT TRANSLATOR ;;;
;;;;;;;;;;;;;;;;;;;;;;;;
InputHistoryHead: dw InputHistory

EnableToggleKey	equ 2915h ; paragraph key

TranslationEnabled db 0
I16sig: dd 0x494C4853
OldI16	dw 0,0
INT16:
	;;pusha
	;; push ds
	;; push es
	;;  mov bp, ax
	;;  
	;;  mov di, 16
	;;  mov bx, [cs:CurrentPtr]
	;;  shr bx, 12
	;;  call PutHC
	;;  mov bx, [cs:CurrentPtr]
	;;  shr bx, 8
	;;  call PutHC
	;;  mov bx, [cs:CurrentPtr]
	;;  shr bx, 4
	;;  call PutHC
	;;  mov bx, [cs:CurrentPtr]
	;;  call PutHC
        ;;
	;;  mov di, 0
	;;  mov bx, bp
	;;  shr bx, 12
	;;  call PutHC
	;;  mov bx, bp
	;;  shr bx, 8
	;;  call PutHC
	;;  mov bx, bp
	;;  shr bx, 4
	;;  call PutHC
	;;  mov bx, bp
	;;  call PutHC
	;; pop es
	;; pop ds
	;;popa
	;;
	;;pushf
	;;push cs
	;;call WrapI16
        ;;
	;;push ax
	;; pushf
	;; pop ax
	;; mov [esp+6], ax
	;; mov byte [cs:LogBuf+13], ' '
	;; test al, 40h
	;; je wasnz
	;; mov byte [cs:LogBuf+13], 'Z'
;;wasnz:
	;;pop ax
        ;;
	;;pusha
	;; push ds
	;; push es
	;;  mov bp, ax
        ;;
	;;  mov di, 8
	;;  mov bx, bp
	;;  shr bx, 12
	;;  call PutHC
	;;  mov bx, bp
	;;  shr bx, 8
	;;  call PutHC
	;;  mov bx, bp
	;;  shr bx, 4
	;;  call PutHC
	;;  mov bx, bp
	;;  call PutHC
	;;  
	;;  push cs
	;;  pop ds
	;;  mov ah, 40h
	;;  mov bx, [LogFileHandle]
	;;  mov dx, LogBuf
	;;  mov cx, 23
	;;  int 21h
	;;  jnc wrok
	;;  mov ah, 2 ;beep
	;;  mov dl, 7
	;;  int 21h
;;wrok:
	;;  mov ah, 3Eh
	;;  mov bx, [LogFileHandle]
	;;  int 21h
	;;  mov ax, 3D02h
	;;  mov dx, LogFileName
	;;  int 21h
	;;  mov [LogFileHandle], ax
	;;  mov bx, ax
	;;  mov ax, 4202h
	;;  xor cx, cx
	;;  xor dx, dx
	;;  int 21h
	;; pop es
	;; pop ds
	;;popa
	;;iret
;;WrapI16:
	cmp ah, 0
	je Func0
	cmp ah, 1
	je Func1
	;cmp ah, 2
	;je Func2
	cmp ah, 10h
	je Func0
	cmp ah, 11h
	je Func1
	;cmp ah, 12h
	;je Func2
	cmp ah, 20h
	je Func0
	cmp ah, 21h
	je Func1
GotoOldI16:
	jmp far [cs:OldI16]

;;LogBuf  db        '???? -> ???? ? (????)', 13,10
;;hexch	db '0123456789ABCDEF'
;;PutHC:	and bx, 15
;;	mov al, [cs:hexch+bx]
;;PutC:	;mov ah, 0Eh
;;	;mov bx, 7
;;	;int 10h
;;	mov [cs:di+LogBuf], al
;;	inc di
;;	ret

Func0:  ; Get and wait for key
	mov [cs:I16Mode], word Func0push
	cmp [cs:CurrentPtr], word 0
	je InputHook0
Func0push:
	push bx
	 push ds
	  push cs
	  pop ds
	  mov bx, [CurrentPtr]
	  mov al, [bx]
	  inc bx
	  cmp [bx], byte 0
	  jne DontReset
	  xor bx,bx
DontReset:
	  mov [CurrentPtr], bx
	  call PutInInputHistory
	  ;mov [cs:FlipFlop], dword 300000
	 pop ds
	pop bx
GotKey:	mov ah, 0
	cmp al, 8
	je Got08
	cmp al, 13
	je Got13
	jmp Ret0
Got08:	mov ah, 0Eh
	jmp Ret0
Got13:	mov ah, 1Ch
	jmp Ret0
Ret0:	iret

Func1:  ; Check if key is available. ZF=1 if NO key. Does not remove key from buffer.
	mov [cs:I16Mode], word Func1push
	cmp [cs:CurrentPtr], word 0
	je InputHook1
Func1push:
	;cmp [cs:CurrentPtr], word 0
	;je GotoOldI16
	;cmp dword [cs:FlipFlop], 0
	;jz Func1Idle
	;dec dword [cs:FlipFlop]
	push bx
	 mov bx, [cs:CurrentPtr]
	 mov al, [cs:bx]
	pop bx
NotIdle:
	and [esp+4], byte 0xBF
	jmp GotKey

Func1Idle:
	;push bx
	; mov bx, [cs:CurrentPtr]
	; mov al, [cs:bx]
	;pop bx
	;mov [cs:FlipFlop], dword 300000
	or [esp+4], byte 0x40
	;sti
	;hlt
	iret
Func2:
	mov al, 0
	iret

InputHook1:
	pushf
	call far [cs:OldI16]
	jz Func1Idle
	cmp ax, EnableToggleKey
	jne NotToggled1
	xor [cs:TranslationEnabled], byte 1
	mov ax, 1000h ; fetch the toggle-key from input buffer
	pushf
	call far [cs:OldI16]
	jmp Func1Idle
NotToggled1:
	and [esp+4], byte 0xBF
	cmp [cs:TranslationEnabled], byte 0
	jz Ret0
	push ds
	 push cs
	 pop ds
	 mov [WhatWasThatInputAgain], ax
	 push bx
	  jmp TestInput
Toggled0:
	xor [cs:TranslationEnabled], byte 1
	mov ax, 1000h
InputHook0:
	pushf
	call far [cs:OldI16]
	cmp ax, EnableToggleKey
	je Toggled0
	cmp [cs:TranslationEnabled], byte 0
	jz Ret0
	push ds
	 push cs
	 pop ds
	 mov [WhatWasThatInputAgain], ax
	 push bx
	  jmp TestInput
DefaultInput:
	  mov ax, [WhatWasThatInputAgain]
	  cmp [cs:I16Mode], word Func0push
	  jne DefaultInputDontSave
	  call PutInInputHistory
DefaultInputDontSave:
	 pop bx
	 mov ax, [WhatWasThatInputAgain]
	pop ds
	iret
PutSequence:
	  pop word [CurrentPtr]
	  cmp [cs:I16Mode], word Func1push
	  jne ps0
	  ; Because we're substituting the input,
	  ; call the BIOS function once to flush
	  ; the pending input key
	  mov ax, 1000h
	  pushf
	  call far [cs:OldI16]
ps0:	 pop bx
	pop ds
	jmp [cs:I16Mode]

PutInInputHistory:
	mov bx, [InputHistoryHead]
	cmp al, 8
	je InputHistoryBackspace
	mov [bx], al
	inc word [InputHistoryHead]
	cmp bx, InputHistoryEnd-1
	jne PutInInputHistoryEnd
	mov word [InputHistoryHead], InputHistory
PutInInputHistoryEnd:
	ret
InputHistoryBackspace:
	cmp bx, InputHistory
	je InputHistoryBackspaceWrap
	dec word [InputHistoryHead]
	ret
InputHistoryBackspaceWrap:
	mov word [InputHistoryHead], InputHistoryEnd-1
	ret

GetHistory1:	mov bx,-1
		jmp GetHistory
GetHistory2:	mov bx,-2
		jmp GetHistory
GetHistory3:	mov bx,-3
		jmp GetHistory
GetHistory4:	mov bx,-4
		jmp GetHistory
GetHistory5:	mov bx,-5
		;jmp GetHistory
GetHistory:
	add bx, [InputHistoryHead]
	cmp bx, InputHistory
	jae NotInputHistoryWrap
	add bx, InputHistoryEnd-InputHistory
NotInputHistoryWrap:
	mov al, [bx]
	ret

%include "data.asm"

End:;
